{* this is a simple test program for mpcalc.pas.
   It calculates three single functions with extended precision.

   Copyright (C) 1999 Franco Milani (franco@intercity.it)

   You can use or modify this program for personal purposes. You can also
   redistribute it, but only in the original unmodified form. The possible
   changes in the distributed versions will be made by the author, also
   according to hints, requests or bug reports. 

   This program is released in the hope that it will be useful, but on an
   as-is basis. No warranty of any kind is offered, either expressed or
   implied, including, without limitation, the implied warranties of
   merchantability and fitness for a particular purpose.                  *}

program mptest;

uses crt,mpcalc;

var
ve,re,rs : mp;
i,j,x,y,prec,myprec : word;
sg1,sg2,sg3 : boolean;
b : byte;
ch : char;

{* this procedure reads an mp with a maximum of 75 digits on a single
line. nd is the number of digits entered, if nd=0 the input is empty *}

procedure xinput(var e:mp; var nd:word);
begin
i:=0;
sg1:=false;
sg2:=false;
j:=0;
sg3:=true;
repeat
ch:=readkey;
if ch=#0 then ch:=chr(ord(readkey)+128);
if (ch=#8) and ((i>0) or ((i=j) and (j>0)) or ((i=0) and sg2)) then begin
write(#8' '#8);
if i=0 then begin
sg2:=false;
sg3:=true;
end;
if i=j then begin
sg1:=false;
j:=0;
end
else dec(i);
end
else begin
if ((((ch='-') or (ch='+')) and (i=0)) or ((ord(ch)>47) and (ord(ch)<58))
or ((ch=#46) and (i>0) and (i<74) and (not sg1))) and (i<75)
then begin
if (ch='-') or (ch='+') then begin
if (not sg2) then begin
sg2:=true;
sg3:=ch='+';
write(ch)
end;
end
else if ch='.' then begin
sg1:=true;
j:=i;
write(ch);
end
else begin
Inc(i);
e.c[i]:=ord(ch)-48;
write(ch);
end;
end;
end;
until ch=#13;
if i=0 then begin
nd:=0;
exit;
end;
if j=0 then j:=i;
while (e.c[i]=0) and (i>j) do dec(i);
x:=1;
while (e.c[x]=0) and (x<j) do inc(x);
dec(x);
if x>0 then begin
dec(i,x);
dec(j,x);
for y:=1 to i do e.c[y]:=e.c[y+x];
end;
e.n:=i;
e.i:=j;
e.d:=i-j;
if (i=1) and (e.c[1]=0) then e.s:=true else e.s:=sg3;
nd:=i;
writeln;
end;

begin
prec:=167;
myprec:=157;
xprecision(prec);
repeat
clrscr;
writeln('enter a number (CR to exit): ');
xinput(ve,i);
if i=0 then halt;
writeln;
re:=msinh(ve);
b:=xerror;
xapp(re,rs,myprec);
writeln('hyperbolic sine:');
xdis(rs);
if b>0 then writeln('error ',b,', the number is too big')
else begin
rs:=masinh(re);
xapp(rs,rs,myprec);
writeln('inverse hyperbolic sine of the result:');
xdis(rs);
end;
writeln;
re:=mexp(ve);
xapp(re,rs,myprec);
b:=xerror;
writeln('exponential:');
xdis(rs);
if b>0 then writeln('error ',b,', the number is too big')
else begin
rs:=mln(re);
xapp(rs,rs,myprec);
writeln('logarithm of the result:');
xdis(rs);
end;
writeln;
re:=msqrt(ve);
xapp(re,rs,myprec);
b:=xerror;
writeln('square root:');
xdis(rs);
if b>0 then writeln('error ',b,', the number is negative')
else begin
rs:=re*re;
xapp(rs,rs,myprec);
writeln('square of the result:');
xdis(rs);
end;
gotoxy(1,25);
write('press a key... ');
ch:=readkey;
until false;
writeln;
end.
